# Record Class CompressorDescriptor

java.lang.Object
java.lang.Record
htsjdk.samtools.cram.structure.CompressorDescriptor

Record Components:
  `method` - the block compression method
  `arg` - compressor-specific argument, or `ExternalCompressor.NO_COMPRESSION_ARG` if none

public record CompressorDescriptor(BlockCompressionMethod method, int arg) extends Record
Describes which compression method and parameters to use for a CRAM data series block. Pairs a `BlockCompressionMethod` with an optional compressor-specific integer argument (e.g., GZIP compression level, rANS order). Maps 1:1 to `ExternalCompressor.getCompressorForMethod(BlockCompressionMethod, int)`.

## Constructor Summary

Constructors
Constructor
Description
`CompressorDescriptor(BlockCompressionMethod method)`
Create a descriptor for a compression method that takes no argument (e.g., RAW, BZIP2, LZMA, NAME_TOKENISER, FQZCOMP).
`CompressorDescriptor(BlockCompressionMethod method, int arg)`
Creates an instance of a `CompressorDescriptor` record class.

## Method Summary

Modifier and Type
Method
Description
`int`
`arg()`
Returns the value of the `arg` record component.
`final boolean`
`equals(Object o)`
Indicates whether some other object is "equal to" this one.
`final int`
`hashCode()`
Returns a hash code value for this object.
`BlockCompressionMethod`
`method()`
Returns the value of the `method` record component.
`final String`
`toString()`
Returns a string representation of this record class.

### Methods inherited from class Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Constructor Details

### CompressorDescriptor

public CompressorDescriptor(BlockCompressionMethod method)
Create a descriptor for a compression method that takes no argument (e.g., RAW, BZIP2, LZMA, NAME_TOKENISER, FQZCOMP).

Parameters:
  `method` - the block compression method

### CompressorDescriptor

public CompressorDescriptor(BlockCompressionMethod method, int arg)
Creates an instance of a `CompressorDescriptor` record class.

Parameters:
  `method` - the value for the `method` record component
  `arg` - the value for the `arg` record component

## Method Details

### toString

public final String toString()
Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.

Specified by:
  `toString` in class `Record`
Returns:
  a string representation of this object

### hashCode

public final int hashCode()
Returns a hash code value for this object. The value is derived from the hash code of each of the record components.

Specified by:
  `hashCode` in class `Record`
Returns:
  a hash code value for this object

### equals

public final boolean equals(Object o)
Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. Reference components are compared with `Objects::equals(Object,Object)`; primitive components are compared with the `compare` method from their corresponding wrapper classes.

Specified by:
  `equals` in class `Record`
Parameters:
  `o` - the object with which to compare
Returns:
  `true` if this object is the same as the `o` argument; `false` otherwise.

### method

public BlockCompressionMethod method()
Returns the value of the `method` record component.

Returns:
  the value of the `method` record component

### arg

public int arg()
Returns the value of the `arg` record component.

Returns:
  the value of the `arg` record component